﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Public X,Y As Float
End Sub

Public Sub Initialize As Point
	Return Me
End Sub

'Creates a new point
Public Sub XY(x_ As Float, y_ As Float) As Point
	Private p As Point
	p.Initialize
	p.X = x_
	p.Y = y_
	Return p
End Sub

'Adds X Y of p2 to X Y of this point
Public Sub Add(p2 As Point) As Point
	Private p As Point
	p.Initialize
	p.X = X + p2.X
	p.Y = Y + p2.Y
	Return p
End Sub

'Subtracts X Y of p2 from X Y of this point
Public Sub Subtract(p2 As Point) As Point
	Private p As Point
	p.Initialize
	p.X = X - p2.X
	p.Y = Y - p2.Y
	Return p
End Sub

'Computes distance between two points
Public Sub Distance(p2 As Point) As Float
	Dim dif As Point = XY(X, Y).Subtract(p2)
	Return Sqrt(dif.X * dif.X + dif.Y * dif.Y)
End Sub

'Computes inner.dot product of two points (a,b).(x,y) => ax + by
Public Sub DotProduct(p2 As Point) As Float
	Return X * p2.X + Y * p2.Y
End Sub

'Myltiplies both X and Y by a value
Public Sub MultiplyValue(Amount As Float) As Point
	Private p As Point
	p.Initialize
	p.X = Amount * X
	p.Y = Amount * Y
	Return p
End Sub

'Powers both X and Y to an exponent value
Public Sub ToPowerOf(Exponent As Float) As Point
	Private p As Point
	p.Initialize
	p.X = Power(X, Exponent)
	p.Y = Power(Y, Exponent)
	Return p
End Sub

'Returns a point that is partway (fraction) along the line between two points
Public Sub PartwayTo(p2 As Point, fraction As Float) As Point
	Private p As Point
	p.Initialize
	p.X = X + fraction * (p2.X - X)
	p.Y = Y + fraction * (p2.Y - Y)
	Return p
End Sub

'Copies a Point
Public Sub Copy As Point
	Return XY(X, Y)
End Sub

'Subtract a value from both X and Y
Public Sub SubtractValue(amount As Float) As Point
	Private p As Point
	p.Initialize
	p.X = X - amount
	p.Y = Y - amount
	Return p
End Sub

'Add a value to both X and Y
Public Sub AddValue(amount As Float) As Point
	Private p As Point
	p.Initialize
	p.X = X + amount
	p.Y = Y + amount
	Return p
End Sub

'Test if two points are equal
Public Sub IsEQ(p As Point) As Boolean
	Return ((X = p.X) And (Y = p.Y))
End Sub

'Create a rectangle from two points on diagonal
Public Sub rectangle(p2 As Point) As B4XRect
	Dim r As B4XRect
	r.Initialize(X, Y, p2.X, p2.Y)
	Return r
End Sub